import * as Entity from "./entity.mjs";
import * as Levels from "./levels/main.mjs";

import * as Event from "./event.mjs";
import * as Progress from "./progress.mjs";



let last_loaded;

export function load (id) {
	last_loaded = id;
	Progress.set("current_level", id);

	Event.trigger("level/unload");

	const level = Levels.get_level(id);

	Event.trigger("level/load/player", level.player);
	Event.trigger("level/load/goal", level.goal);
	Event.trigger("level/load/enemy", level.enemies);
}

export function restart () {
	load(last_loaded);
}

Event.listen("level/restart", data => {
	restart();
});

Event.listen("level/win", _ => {
	const level = Levels.get_level(last_loaded);
	if (level.hasOwnProperty("next_level")) {
		load(level.next_level);
	}
})

export function load_current () {
	if (Progress.has("current_level")) {
		load(Progress.get("current_level"));
	} else {
		load(1);
	}
}
