import { create_level } from "./core.mjs";

import bounding_walls from "./templates/bounding_walls.mjs";



create_level(6, {
	player: {
		pos: {
			x: 20,
			y: 570,
		},
		size: {
			x: 10,
			y: 10,
		},
		speed: 40,
	},
	goal: {
		pos: {
			x: 700,
			y: 300,
		},
	},
	next_level: 6,
	enemies: [
		...bounding_walls(10),

		// wall with holes
		{
			pos: [50, 50],
			size: [20, 50],
		},
		{
			pos: [50, 150],
			size: [20, 100],
		},
		{
			pos: [50, 300],
			size: [20, 50],
		},
		{
			pos: [50, 400],
			size: [20, 100],
		},
		{
			pos: [50, 550],
			size: [20, 100],
		},
		// back segment
		{
			pos: [70, 50],
			size: [20, 550],
		},

		// wall patroller
		{
			pos: [0, 0],
			size: [40, 10],
			behaviour: "path",
			meta: [
				["points", [
					[10, 10],
					[10, 580],
					[10, 580],
				]],
				["speeds", [
					1,
					2,
					1/4,
				]],
				["offset", 3/4],
			],
		},

		// big time limit thing
		{
			pos: [0, 0],
			size: [400, 600],
			behaviour: "path",
			meta: [
				["points", [
					[800, 0],
					[800, 0],
					[400, 0],
				]],
				["speeds", [
					1,
					1/100,
					0,
				]],
				["offset", 1],
			],
		},
	],
	effects: [],
});
