export default function generate_oscillator (count, data) {
	const result = [];

	const { pos, size, offset, spacing, meta } = data;

	for (let n = 0; n < count; n++) {
		result.push({
			pos: [pos.x, pos.y + n*(spacing + size.y)],
			size: [size.x, size.y],
			behaviour: "sine_x",
			meta: [
				["movement_scale", meta.movement_scale],
				["movement_speed", meta.movement_speed],
				["offset", offset + n/2],
			],
		});
	}

	return result;
}
