function to_string (map) {
	return JSON.stringify([...map.entries()]);
}

function from_string (str) {
	return new Map(JSON.parse(str));
}

function get_game_data () {
	const data = from_string(localStorage.getItem("precision_game_data"));
	if (data === null) return new Map();
	return data;
}

function set_game_data (data) {
	localStorage.setItem("precision_game_data", to_string(data));
}

export function get (key) {
	return get_game_data().get(key);
}

export function has (key) {
	return get_game_data().has(key);
}

export function set (key, value) {
	const data = get_game_data();
	data.set(key, value);
	set_game_data(data);
}
