import { create_level } from "./core.mjs";

import generate_oscillator from "./templates/oscillator.mjs";



create_level(5, {
	player: {
		pos: {
			x: 10,
			y: 300 - 20,
		},
		size: {
			x: 40,
			y: 40,
		},
		speed: 120,
	},
	goal: {
		pos: {
			x: 750,
			y: 0,
		},
		size: {
			x: 50,
			y: 600,
		}
	},
	next_level: 6,
	enemies: [
		...generate_oscillator(11, {
			pos: {
				x: 380,
				y: 0,
			},
			size: {
				x: 20,
				y: 20,
			},
			offset: 0,
			spacing: 38,
			meta: {
				movement_scale: 280,
				movement_speed: 1/8,
			},
		}),

		...generate_oscillator(5, {
			pos: {
				x: 380,
				y: 0,
			},
			size: {
				x: 50,
				y: 50,
			},
			offset: 0,
			spacing: 87.5,
			meta: {
				movement_scale: 280,
				movement_speed: 1/10,
			},
		}),

		// these make it non-trivial to exploit going out of bounds:
		{
			pos: [220, 220],
			size: [30, 160],
			behaviour: "sine_y",
			meta: [
				["movement_scale", 350],
				["movement_speed", 1/4],
				["offset", 3/4],
			],
		},
		{
			pos: [370, 220],
			size: [30, 160],
			behaviour: "sine_y",
			meta: [
				["movement_scale", 400],
				["movement_speed", 1/2],
				["offset", 0],
			],
		},
		{
			pos: [520, 220],
			size: [30, 160],
			behaviour: "sine_y",
			meta: [
				["movement_scale", 350],
				["movement_speed", 1/4],
				["offset", 1/4],
			],
		},
		// left wall
		{
			pos: [-10, 0],
			size: [10, 600],
		},
		// ceiling & floor
		{
			pos: [0, -110],
			size: [800, 10],
		},
		{
			pos: [0, 700],
			size: [800, 10],
		},
	],
});
